#include <pthread.h>
#include <stdio.h>
#include <imsls.h>
void *ex1(void* arg);
void *ex2(void* arg);
int main()
{
  pthread_t       thread1;
  pthread_t       thread2;

  /* Disable IMSL signal trapping. */
  imsls_error_options(IMSLS_SET_SIGNAL_TRAPPING, 0, 0);

  /* Create two threads. */
  if (pthread_create(&thread1, NULL ,ex1, (void *)NULL) != 0)
    perror("pthread_create"), exit(1); 
  if (pthread_create(&thread2, NULL ,ex2, (void *)NULL) != 0)
    perror("pthread_create"), exit(1); 
  
  /* Wait for threads to finish. */
  if (pthread_join(thread1, NULL) != 0)
    perror("pthread_join"),exit(1);
  if (pthread_join(thread2, NULL) != 0)
    perror("pthread_join"),exit(1);
  
}
void *ex1(void* arg)
{
  float *rand_nums = NULL;
  FILE  *file_ptr;
  /* Open a file to write the result in. */
  file_ptr = fopen("ex1.out", "w");
  /* Set the output file for this thread. */
  imsls_output_file(IMSLS_SET_OUTPUT_FILE, file_ptr, 0);
  /* Compute 5 random numbers. */
  imsls_random_seed_set(12345);
  rand_nums = imsls_f_random_uniform(5, 0);
  /* Output random numbers. */
  imsls_f_write_matrix("Random Numbers", 5, 1, rand_nums, 0);
  if (rand_nums) imsls_free(rand_nums);
  fclose(file_ptr);
}
void *ex2(void* arg)
{	
  int n_intervals=10;
  int n_observations=30;
  float *table;
  float x[] = {0.77, 1.74, 0.81, 1.20, 1.95, 1.20, 0.47, 1.43, 3.37,
	       2.20, 3.00, 3.09, 1.51, 2.10, 0.52, 1.62, 1.31, 0.32,
	       0.59, 0.81, 2.81, 1.87, 1.18, 1.35, 4.75, 2.48, 0.96,
	       1.89, 0.90, 2.05};
  FILE  *file_ptr;
  /* Open a file to write the result in. */
  file_ptr = fopen("ex2.out", "w");
  /* Set the output file for this thread. */
  imsls_output_file(IMSLS_SET_OUTPUT_FILE, file_ptr, 0);
  table = imsls_f_table_oneway (n_observations, x, n_intervals, 0);
  imsls_f_write_matrix("counts", 1, n_intervals, table, 0);
  
  if (table) imsls_free(table);
  fclose(file_ptr);
}
